/*
 *  ClienteRefConverter
 *
 * Created on 13 de mayo de 2008, 17:30
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package es.ua.jtech.servcweb.foro.converter;

import es.ua.jtech.servcweb.foro.jpa.Cliente;
import java.net.URI;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlAttribute;
import javax.ws.rs.core.UriBuilder;


/**
 *
 * @author Miguel Angel
 */

@XmlRootElement(name = "clienteRef")
public class ClienteRefConverter {
    private Cliente entity;
    private boolean isUriExtendable;
    private URI uri;
    
    /** Creates a new instance of ClienteRefConverter */
    public ClienteRefConverter() {
    }

    /**
     * Creates a new instance of ClienteRefConverter.
     *
     * @param entity associated entity
     * @param uri associated uri
     * @param isUriExtendable indicates whether the uri can be extended
     */
    public ClienteRefConverter(Cliente entity, URI uri, boolean isUriExtendable) {
        this.entity = entity;
        this.uri = uri;
        this.isUriExtendable = isUriExtendable;
    }

    /**
     * Getter for id.
     *
     * @return value for id
     */
    @XmlElement
    public Integer getId() {
        return entity.getId();
    }

    /**
     * Returns the URI associated with this reference converter.
     *
     * @return the converted uri
     */
    @XmlAttribute(name = "uri")
    public URI getResourceUri() {
        if (isUriExtendable) {
            return UriBuilder.fromUri(uri).path(entity.getId() + "/").build();
        }
        return uri;
    }

    /**
     * Sets the URI for this reference converter.
     *
     */
    public void setResourceUri(URI uri) {
        this.uri = uri;
    }

    /**
     * Returns the Cliente entity.
     *
     * @return Cliente entity
     */
    @XmlTransient
    public Cliente getEntity() {
        ClienteConverter result = UriResolver.getInstance().resolve(ClienteConverter.class, uri);
        if (result != null) {
            return result.getEntity();
        }
        return null;
    }
}
